<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.12">
  <meta name="author" content="Copyright (c) 2010, 2023 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../favicon.png">
  <title>Statements | Chi documentation (Incubation)</title>
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans:300,300italic,400,400italic,600,600italic%7CNoto+Serif:400,400italic,700,700italic%7CDroid+Sans+Mono:400,700">
  <style>
/* Asciidoctor default stylesheet | MIT License | https://asciidoctor.org */
/* Uncomment @import statement to use as custom stylesheet */
/*@import "https://fonts.googleapis.com/css?family=Open+Sans:300,300italic,400,400italic,600,600italic%7CNoto+Serif:400,400italic,700,700italic%7CDroid+Sans+Mono:400,700";*/
article,aside,details,figcaption,figure,footer,header,hgroup,main,nav,section{display:block}
audio,video{display:inline-block}
audio:not([controls]){display:none;height:0}
html{font-family:sans-serif;-ms-text-size-adjust:100%;-webkit-text-size-adjust:100%}
a{background:none}
a:focus{outline:thin dotted}
a:active,a:hover{outline:0}
h1{font-size:2em;margin:.67em 0}
abbr[title]{border-bottom:1px dotted}
b,strong{font-weight:bold}
dfn{font-style:italic}
hr{-moz-box-sizing:content-box;box-sizing:content-box;height:0}
mark{background:#ff0;color:#000}
code,kbd,pre,samp{font-family:monospace;font-size:1em}
pre{white-space:pre-wrap}
q{quotes:"\201C" "\201D" "\2018" "\2019"}
small{font-size:80%}
sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}
sup{top:-.5em}
sub{bottom:-.25em}
img{border:0}
svg:not(:root){overflow:hidden}
figure{margin:0}
fieldset{border:1px solid silver;margin:0 2px;padding:.35em .625em .75em}
legend{border:0;padding:0}
button,input,select,textarea{font-family:inherit;font-size:100%;margin:0}
button,input{line-height:normal}
button,select{text-transform:none}
button,html input[type="button"],input[type="reset"],input[type="submit"]{-webkit-appearance:button;cursor:pointer}
button[disabled],html input[disabled]{cursor:default}
input[type="checkbox"],input[type="radio"]{box-sizing:border-box;padding:0}
button::-moz-focus-inner,input::-moz-focus-inner{border:0;padding:0}
textarea{overflow:auto;vertical-align:top}
table{border-collapse:collapse;border-spacing:0}
*,*::before,*::after{-moz-box-sizing:border-box;-webkit-box-sizing:border-box;box-sizing:border-box}
html,body{font-size:100%}
body{background:#fff;color:rgba(0,0,0,.8);padding:0;margin:0;font-family:"Noto Serif","DejaVu Serif",serif;font-weight:400;font-style:normal;line-height:1;position:relative;cursor:auto;tab-size:4;word-wrap:anywhere;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased}
a:hover{cursor:pointer}
img,object,embed{max-width:100%;height:auto}
object,embed{height:100%}
img{-ms-interpolation-mode:bicubic}
.left{float:left!important}
.right{float:right!important}
.text-left{text-align:left!important}
.text-right{text-align:right!important}
.text-center{text-align:center!important}
.text-justify{text-align:justify!important}
.hide{display:none}
img,object,svg{display:inline-block;vertical-align:middle}
textarea{height:auto;min-height:50px}
select{width:100%}
.subheader,.admonitionblock td.content>.title,.audioblock>.title,.exampleblock>.title,.imageblock>.title,.listingblock>.title,.literalblock>.title,.stemblock>.title,.openblock>.title,.paragraph>.title,.quoteblock>.title,table.tableblock>.title,.verseblock>.title,.videoblock>.title,.dlist>.title,.olist>.title,.ulist>.title,.qlist>.title,.hdlist>.title{line-height:1.45;color:#7a2518;font-weight:400;margin-top:0;margin-bottom:.25em}
div,dl,dt,dd,ul,ol,li,h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6,pre,form,p,blockquote,th,td{margin:0;padding:0}
a{color:#2156a5;text-decoration:underline;line-height:inherit}
a:hover,a:focus{color:#1d4b8f}
a img{border:0}
p{font-family:inherit;font-weight:400;font-size:1em;line-height:1.6;margin-bottom:1.25em;text-rendering:optimizeLegibility}
p aside{font-size:.875em;line-height:1.35;font-style:italic}
h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{font-family:"Open Sans","DejaVu Sans",sans-serif;font-weight:300;font-style:normal;color:#ba3925;text-rendering:optimizeLegibility;margin-top:1em;margin-bottom:.5em;line-height:1.0125em}
h1 small,h2 small,h3 small,#toctitle small,.sidebarblock>.content>.title small,h4 small,h5 small,h6 small{font-size:60%;color:#e99b8f;line-height:0}
h1{font-size:2.125em}
h2{font-size:1.6875em}
h3,#toctitle,.sidebarblock>.content>.title{font-size:1.375em}
h4,h5{font-size:1.125em}
h6{font-size:1em}
hr{border:solid #dddddf;border-width:1px 0 0;clear:both;margin:1.25em 0 1.1875em;height:0}
em,i{font-style:italic;line-height:inherit}
strong,b{font-weight:bold;line-height:inherit}
small{font-size:60%;line-height:inherit}
code{font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;font-weight:400;color:rgba(0,0,0,.9)}
ul,ol,dl{font-size:1em;line-height:1.6;margin-bottom:1.25em;list-style-position:outside;font-family:inherit}
ul,ol{margin-left:1.5em}
ul li ul,ul li ol{margin-left:1.25em;margin-bottom:0;font-size:1em}
ul.square li ul,ul.circle li ul,ul.disc li ul{list-style:inherit}
ul.square{list-style-type:square}
ul.circle{list-style-type:circle}
ul.disc{list-style-type:disc}
ol li ul,ol li ol{margin-left:1.25em;margin-bottom:0}
dl dt{margin-bottom:.3125em;font-weight:bold}
dl dd{margin-bottom:1.25em}
abbr,acronym{text-transform:uppercase;font-size:90%;color:rgba(0,0,0,.8);border-bottom:1px dotted #ddd;cursor:help}
abbr{text-transform:none}
blockquote{margin:0 0 1.25em;padding:.5625em 1.25em 0 1.1875em;border-left:1px solid #ddd}
blockquote cite{display:block;font-size:.9375em;color:rgba(0,0,0,.6)}
blockquote cite::before{content:"\2014 \0020"}
blockquote cite a,blockquote cite a:visited{color:rgba(0,0,0,.6)}
blockquote,blockquote p{line-height:1.6;color:rgba(0,0,0,.85)}
@media screen and (min-width:768px){h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{line-height:1.2}
h1{font-size:2.75em}
h2{font-size:2.3125em}
h3,#toctitle,.sidebarblock>.content>.title{font-size:1.6875em}
h4{font-size:1.4375em}}
table{background:#fff;margin-bottom:1.25em;border:solid 1px #dedede;word-wrap:normal}
table thead,table tfoot{background:#f7f8f7}
table thead tr th,table thead tr td,table tfoot tr th,table tfoot tr td{padding:.5em .625em .625em;font-size:inherit;color:rgba(0,0,0,.8);text-align:left}
table tr th,table tr td{padding:.5625em .625em;font-size:inherit;color:rgba(0,0,0,.8)}
table tr.even,table tr.alt{background:#f8f8f7}
table thead tr th,table tfoot tr th,table tbody tr td,table tr td,table tfoot tr td{line-height:1.6}
h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{line-height:1.2;word-spacing:-.05em}
h1 strong,h2 strong,h3 strong,#toctitle strong,.sidebarblock>.content>.title strong,h4 strong,h5 strong,h6 strong{font-weight:400}
.center{margin-left:auto;margin-right:auto}
.stretch{width:100%}
.clearfix::before,.clearfix::after,.float-group::before,.float-group::after{content:" ";display:table}
.clearfix::after,.float-group::after{clear:both}
:not(pre).nobreak{word-wrap:normal}
:not(pre).nowrap{white-space:nowrap}
:not(pre).pre-wrap{white-space:pre-wrap}
:not(pre):not([class^=L])>code{font-size:.9375em;font-style:normal!important;letter-spacing:0;padding:.1em .5ex;word-spacing:-.15em;background:#f7f7f8;-webkit-border-radius:4px;border-radius:4px;line-height:1.45;text-rendering:optimizeSpeed}
pre{color:rgba(0,0,0,.9);font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;line-height:1.45;text-rendering:optimizeSpeed}
pre code,pre pre{color:inherit;font-size:inherit;line-height:inherit}
pre>code{display:block}
pre.nowrap,pre.nowrap pre{white-space:pre;word-wrap:normal}
em em{font-style:normal}
strong strong{font-weight:400}
.keyseq{color:rgba(51,51,51,.8)}
kbd{font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;display:inline-block;color:rgba(0,0,0,.8);font-size:.65em;line-height:1.45;background:#f7f7f7;border:1px solid #ccc;-webkit-border-radius:3px;border-radius:3px;-webkit-box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em white inset;box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em #fff inset;margin:0 .15em;padding:.2em .5em;vertical-align:middle;position:relative;top:-.1em;white-space:nowrap}
.keyseq kbd:first-child{margin-left:0}
.keyseq kbd:last-child{margin-right:0}
.menuseq,.menuref{color:#000}
.menuseq b:not(.caret),.menuref{font-weight:inherit}
.menuseq{word-spacing:-.02em}
.menuseq b.caret{font-size:1.25em;line-height:.8}
.menuseq i.caret{font-weight:bold;text-align:center;width:.45em}
b.button::before,b.button::after{position:relative;top:-1px;font-weight:400}
b.button::before{content:"[";padding:0 3px 0 2px}
b.button::after{content:"]";padding:0 2px 0 3px}
p a>code:hover{color:rgba(0,0,0,.9)}
#header,#content,#footnotes,#footer{width:100%;margin-left:auto;margin-right:auto;margin-top:0;margin-bottom:0;max-width:62.5em;*zoom:1;position:relative;padding-left:.9375em;padding-right:.9375em}
#header::before,#header::after,#content::before,#content::after,#footnotes::before,#footnotes::after,#footer::before,#footer::after{content:" ";display:table}
#header::after,#content::after,#footnotes::after,#footer::after{clear:both}
#content{margin-top:1.25em}
#content::before{content:none}
#header>h1:first-child{color:rgba(0,0,0,.85);margin-top:2.25rem;margin-bottom:0}
#header>h1:first-child+#toc{margin-top:8px;border-top:1px solid #dddddf}
#header>h1:only-child,body.toc2 #header>h1:nth-last-child(2){border-bottom:1px solid #dddddf;padding-bottom:8px}
#header .details{border-bottom:1px solid #dddddf;line-height:1.45;padding-top:.25em;padding-bottom:.25em;padding-left:.25em;color:rgba(0,0,0,.6);display:-ms-flexbox;display:-webkit-flex;display:flex;-ms-flex-flow:row wrap;-webkit-flex-flow:row wrap;flex-flow:row wrap}
#header .details span:first-child{margin-left:-.125em}
#header .details span.email a{color:rgba(0,0,0,.85)}
#header .details br{display:none}
#header .details br+span::before{content:"\00a0\2013\00a0"}
#header .details br+span.author::before{content:"\00a0\22c5\00a0";color:rgba(0,0,0,.85)}
#header .details br+span#revremark::before{content:"\00a0|\00a0"}
#header #revnumber{text-transform:capitalize}
#header #revnumber::after{content:"\00a0"}
#content>h1:first-child:not([class]){color:rgba(0,0,0,.85);border-bottom:1px solid #dddddf;padding-bottom:8px;margin-top:0;padding-top:1rem;margin-bottom:1.25rem}
#toc{border-bottom:1px solid #e7e7e9;padding-bottom:.5em}
#toc>ul{margin-left:.125em}
#toc ul.sectlevel0>li>a{font-style:italic}
#toc ul.sectlevel0 ul.sectlevel1{margin:.5em 0}
#toc ul{font-family:"Open Sans","DejaVu Sans",sans-serif;list-style-type:none}
#toc li{line-height:1.3334;margin-top:.3334em}
#toc a{text-decoration:none}
#toc a:active{text-decoration:underline}
#toctitle{color:#7a2518;font-size:1.2em}
@media screen and (min-width:768px){#toctitle{font-size:1.375em}
body.toc2{padding-left:15em;padding-right:0}
#toc.toc2{margin-top:0!important;background:#f8f8f7;position:fixed;width:15em;left:0;top:0;border-right:1px solid #e7e7e9;border-top-width:0!important;border-bottom-width:0!important;z-index:1000;padding:1.25em 1em;height:100%;overflow:auto}
#toc.toc2 #toctitle{margin-top:0;margin-bottom:.8rem;font-size:1.2em}
#toc.toc2>ul{font-size:.9em;margin-bottom:0}
#toc.toc2 ul ul{margin-left:0;padding-left:1em}
#toc.toc2 ul.sectlevel0 ul.sectlevel1{padding-left:0;margin-top:.5em;margin-bottom:.5em}
body.toc2.toc-right{padding-left:0;padding-right:15em}
body.toc2.toc-right #toc.toc2{border-right-width:0;border-left:1px solid #e7e7e9;left:auto;right:0}}
@media screen and (min-width:1280px){body.toc2{padding-left:20em;padding-right:0}
#toc.toc2{width:20em}
#toc.toc2 #toctitle{font-size:1.375em}
#toc.toc2>ul{font-size:.95em}
#toc.toc2 ul ul{padding-left:1.25em}
body.toc2.toc-right{padding-left:0;padding-right:20em}}
#content #toc{border-style:solid;border-width:1px;border-color:#e0e0dc;margin-bottom:1.25em;padding:1.25em;background:#f8f8f7;-webkit-border-radius:4px;border-radius:4px}
#content #toc>:first-child{margin-top:0}
#content #toc>:last-child{margin-bottom:0}
#footer{max-width:none;background:rgba(0,0,0,.8);padding:1.25em}
#footer-text{color:rgba(255,255,255,.8);line-height:1.44}
#content{margin-bottom:.625em}
.sect1{padding-bottom:.625em}
@media screen and (min-width:768px){#content{margin-bottom:1.25em}
.sect1{padding-bottom:1.25em}}
.sect1:last-child{padding-bottom:0}
.sect1+.sect1{border-top:1px solid #e7e7e9}
#content h1>a.anchor,h2>a.anchor,h3>a.anchor,#toctitle>a.anchor,.sidebarblock>.content>.title>a.anchor,h4>a.anchor,h5>a.anchor,h6>a.anchor{position:absolute;z-index:1001;width:1.5ex;margin-left:-1.5ex;display:block;text-decoration:none!important;visibility:hidden;text-align:center;font-weight:400}
#content h1>a.anchor::before,h2>a.anchor::before,h3>a.anchor::before,#toctitle>a.anchor::before,.sidebarblock>.content>.title>a.anchor::before,h4>a.anchor::before,h5>a.anchor::before,h6>a.anchor::before{content:"\00A7";font-size:.85em;display:block;padding-top:.1em}
#content h1:hover>a.anchor,#content h1>a.anchor:hover,h2:hover>a.anchor,h2>a.anchor:hover,h3:hover>a.anchor,#toctitle:hover>a.anchor,.sidebarblock>.content>.title:hover>a.anchor,h3>a.anchor:hover,#toctitle>a.anchor:hover,.sidebarblock>.content>.title>a.anchor:hover,h4:hover>a.anchor,h4>a.anchor:hover,h5:hover>a.anchor,h5>a.anchor:hover,h6:hover>a.anchor,h6>a.anchor:hover{visibility:visible}
#content h1>a.link,h2>a.link,h3>a.link,#toctitle>a.link,.sidebarblock>.content>.title>a.link,h4>a.link,h5>a.link,h6>a.link{color:#ba3925;text-decoration:none}
#content h1>a.link:hover,h2>a.link:hover,h3>a.link:hover,#toctitle>a.link:hover,.sidebarblock>.content>.title>a.link:hover,h4>a.link:hover,h5>a.link:hover,h6>a.link:hover{color:#a53221}
details,.audioblock,.imageblock,.literalblock,.listingblock,.stemblock,.videoblock{margin-bottom:1.25em}
details>summary:first-of-type{cursor:pointer;display:list-item;outline:none;margin-bottom:.75em}
.admonitionblock td.content>.title,.audioblock>.title,.exampleblock>.title,.imageblock>.title,.listingblock>.title,.literalblock>.title,.stemblock>.title,.openblock>.title,.paragraph>.title,.quoteblock>.title,table.tableblock>.title,.verseblock>.title,.videoblock>.title,.dlist>.title,.olist>.title,.ulist>.title,.qlist>.title,.hdlist>.title{text-rendering:optimizeLegibility;text-align:left;font-family:"Noto Serif","DejaVu Serif",serif;font-size:1rem;font-style:italic}
table.tableblock.fit-content>caption.title{white-space:nowrap;width:0}
.paragraph.lead>p,#preamble>.sectionbody>[class="paragraph"]:first-of-type p{font-size:1.21875em;line-height:1.6;color:rgba(0,0,0,.85)}
table.tableblock #preamble>.sectionbody>[class="paragraph"]:first-of-type p{font-size:inherit}
.admonitionblock>table{border-collapse:separate;border:0;background:none;width:100%}
.admonitionblock>table td.icon{text-align:center;width:80px}
.admonitionblock>table td.icon img{max-width:none}
.admonitionblock>table td.icon .title{font-weight:bold;font-family:"Open Sans","DejaVu Sans",sans-serif;text-transform:uppercase}
.admonitionblock>table td.content{padding-left:1.125em;padding-right:1.25em;border-left:1px solid #dddddf;color:rgba(0,0,0,.6);word-wrap:anywhere}
.admonitionblock>table td.content>:last-child>:last-child{margin-bottom:0}
.exampleblock>.content{border-style:solid;border-width:1px;border-color:#e6e6e6;margin-bottom:1.25em;padding:1.25em;background:#fff;-webkit-border-radius:4px;border-radius:4px}
.exampleblock>.content>:first-child{margin-top:0}
.exampleblock>.content>:last-child{margin-bottom:0}
.sidebarblock{border-style:solid;border-width:1px;border-color:#dbdbd6;margin-bottom:1.25em;padding:1.25em;background:#f3f3f2;-webkit-border-radius:4px;border-radius:4px}
.sidebarblock>:first-child{margin-top:0}
.sidebarblock>:last-child{margin-bottom:0}
.sidebarblock>.content>.title{color:#7a2518;margin-top:0;text-align:center}
.exampleblock>.content>:last-child>:last-child,.exampleblock>.content .olist>ol>li:last-child>:last-child,.exampleblock>.content .ulist>ul>li:last-child>:last-child,.exampleblock>.content .qlist>ol>li:last-child>:last-child,.sidebarblock>.content>:last-child>:last-child,.sidebarblock>.content .olist>ol>li:last-child>:last-child,.sidebarblock>.content .ulist>ul>li:last-child>:last-child,.sidebarblock>.content .qlist>ol>li:last-child>:last-child{margin-bottom:0}
.literalblock pre,.listingblock>.content>pre{-webkit-border-radius:4px;border-radius:4px;overflow-x:auto;padding:1em;font-size:.8125em}
@media screen and (min-width:768px){.literalblock pre,.listingblock>.content>pre{font-size:.90625em}}
@media screen and (min-width:1280px){.literalblock pre,.listingblock>.content>pre{font-size:1em}}
.literalblock pre,.listingblock>.content>pre:not(.highlight),.listingblock>.content>pre[class="highlight"],.listingblock>.content>pre[class^="highlight "]{background:#f7f7f8}
.literalblock.output pre{color:#f7f7f8;background:rgba(0,0,0,.9)}
.listingblock>.content{position:relative}
.listingblock code[data-lang]::before{display:none;content:attr(data-lang);position:absolute;font-size:.75em;top:.425rem;right:.5rem;line-height:1;text-transform:uppercase;color:inherit;opacity:.5}
.listingblock:hover code[data-lang]::before{display:block}
.listingblock.terminal pre .command::before{content:attr(data-prompt);padding-right:.5em;color:inherit;opacity:.5}
.listingblock.terminal pre .command:not([data-prompt])::before{content:"$"}
.listingblock pre.highlightjs{padding:0}
.listingblock pre.highlightjs>code{padding:1em;-webkit-border-radius:4px;border-radius:4px}
.listingblock pre.prettyprint{border-width:0}
.prettyprint{background:#f7f7f8}
pre.prettyprint .linenums{line-height:1.45;margin-left:2em}
pre.prettyprint li{background:none;list-style-type:inherit;padding-left:0}
pre.prettyprint li code[data-lang]::before{opacity:1}
pre.prettyprint li:not(:first-child) code[data-lang]::before{display:none}
table.linenotable{border-collapse:separate;border:0;margin-bottom:0;background:none}
table.linenotable td[class]{color:inherit;vertical-align:top;padding:0;line-height:inherit;white-space:normal}
table.linenotable td.code{padding-left:.75em}
table.linenotable td.linenos{border-right:1px solid currentColor;opacity:.35;padding-right:.5em}
pre.pygments .lineno{border-right:1px solid currentColor;opacity:.35;display:inline-block;margin-right:.75em}
pre.pygments .lineno::before{content:"";margin-right:-.125em}
.quoteblock{margin:0 1em 1.25em 1.5em;display:table}
.quoteblock:not(.excerpt)>.title{margin-left:-1.5em;margin-bottom:.75em}
.quoteblock blockquote,.quoteblock p{color:rgba(0,0,0,.85);font-size:1.15rem;line-height:1.75;word-spacing:.1em;letter-spacing:0;font-style:italic;text-align:justify}
.quoteblock blockquote{margin:0;padding:0;border:0}
.quoteblock blockquote::before{content:"\201c";float:left;font-size:2.75em;font-weight:bold;line-height:.6em;margin-left:-.6em;color:#7a2518;text-shadow:0 1px 2px rgba(0,0,0,.1)}
.quoteblock blockquote>.paragraph:last-child p{margin-bottom:0}
.quoteblock .attribution{margin-top:.75em;margin-right:.5ex;text-align:right}
.verseblock{margin:0 1em 1.25em}
.verseblock pre{font-family:"Open Sans","DejaVu Sans",sans;font-size:1.15rem;color:rgba(0,0,0,.85);font-weight:300;text-rendering:optimizeLegibility}
.verseblock pre strong{font-weight:400}
.verseblock .attribution{margin-top:1.25rem;margin-left:.5ex}
.quoteblock .attribution,.verseblock .attribution{font-size:.9375em;line-height:1.45;font-style:italic}
.quoteblock .attribution br,.verseblock .attribution br{display:none}
.quoteblock .attribution cite,.verseblock .attribution cite{display:block;letter-spacing:-.025em;color:rgba(0,0,0,.6)}
.quoteblock.abstract blockquote::before,.quoteblock.excerpt blockquote::before,.quoteblock .quoteblock blockquote::before{display:none}
.quoteblock.abstract blockquote,.quoteblock.abstract p,.quoteblock.excerpt blockquote,.quoteblock.excerpt p,.quoteblock .quoteblock blockquote,.quoteblock .quoteblock p{line-height:1.6;word-spacing:0}
.quoteblock.abstract{margin:0 1em 1.25em;display:block}
.quoteblock.abstract>.title{margin:0 0 .375em;font-size:1.15em;text-align:center}
.quoteblock.excerpt>blockquote,.quoteblock .quoteblock{padding:0 0 .25em 1em;border-left:.25em solid #dddddf}
.quoteblock.excerpt,.quoteblock .quoteblock{margin-left:0}
.quoteblock.excerpt blockquote,.quoteblock.excerpt p,.quoteblock .quoteblock blockquote,.quoteblock .quoteblock p{color:inherit;font-size:1.0625rem}
.quoteblock.excerpt .attribution,.quoteblock .quoteblock .attribution{color:inherit;text-align:left;margin-right:0}
p.tableblock:last-child{margin-bottom:0}
td.tableblock>.content{margin-bottom:1.25em;word-wrap:anywhere}
td.tableblock>.content>:last-child{margin-bottom:-1.25em}
table.tableblock,th.tableblock,td.tableblock{border:0 solid #dedede}
table.grid-all>*>tr>*{border-width:1px}
table.grid-cols>*>tr>*{border-width:0 1px}
table.grid-rows>*>tr>*{border-width:1px 0}
table.frame-all{border-width:1px}
table.frame-ends{border-width:1px 0}
table.frame-sides{border-width:0 1px}
table.frame-none>colgroup+*>:first-child>*,table.frame-sides>colgroup+*>:first-child>*{border-top-width:0}
table.frame-none>:last-child>:last-child>*,table.frame-sides>:last-child>:last-child>*{border-bottom-width:0}
table.frame-none>*>tr>:first-child,table.frame-ends>*>tr>:first-child{border-left-width:0}
table.frame-none>*>tr>:last-child,table.frame-ends>*>tr>:last-child{border-right-width:0}
table.stripes-all tr,table.stripes-odd tr:nth-of-type(odd),table.stripes-even tr:nth-of-type(even),table.stripes-hover tr:hover{background:#f8f8f7}
th.halign-left,td.halign-left{text-align:left}
th.halign-right,td.halign-right{text-align:right}
th.halign-center,td.halign-center{text-align:center}
th.valign-top,td.valign-top{vertical-align:top}
th.valign-bottom,td.valign-bottom{vertical-align:bottom}
th.valign-middle,td.valign-middle{vertical-align:middle}
table thead th,table tfoot th{font-weight:bold}
tbody tr th{background:#f7f8f7}
tbody tr th,tbody tr th p,tfoot tr th,tfoot tr th p{color:rgba(0,0,0,.8);font-weight:bold}
p.tableblock>code:only-child{background:none;padding:0}
p.tableblock{font-size:1em}
ol{margin-left:1.75em}
ul li ol{margin-left:1.5em}
dl dd{margin-left:1.125em}
dl dd:last-child,dl dd:last-child>:last-child{margin-bottom:0}
ol>li p,ul>li p,ul dd,ol dd,.olist .olist,.ulist .ulist,.ulist .olist,.olist .ulist{margin-bottom:.625em}
ul.checklist,ul.none,ol.none,ul.no-bullet,ol.no-bullet,ol.unnumbered,ul.unstyled,ol.unstyled{list-style-type:none}
ul.no-bullet,ol.no-bullet,ol.unnumbered{margin-left:.625em}
ul.unstyled,ol.unstyled{margin-left:0}
ul.checklist{margin-left:.625em}
ul.checklist li>p:first-child>.fa-square-o:first-child,ul.checklist li>p:first-child>.fa-check-square-o:first-child{width:1.25em;font-size:.8em;position:relative;bottom:.125em}
ul.checklist li>p:first-child>input[type="checkbox"]:first-child{margin-right:.25em}
ul.inline{display:-ms-flexbox;display:-webkit-box;display:flex;-ms-flex-flow:row wrap;-webkit-flex-flow:row wrap;flex-flow:row wrap;list-style:none;margin:0 0 .625em -1.25em}
ul.inline>li{margin-left:1.25em}
.unstyled dl dt{font-weight:400;font-style:normal}
ol.arabic{list-style-type:decimal}
ol.decimal{list-style-type:decimal-leading-zero}
ol.loweralpha{list-style-type:lower-alpha}
ol.upperalpha{list-style-type:upper-alpha}
ol.lowerroman{list-style-type:lower-roman}
ol.upperroman{list-style-type:upper-roman}
ol.lowergreek{list-style-type:lower-greek}
.hdlist>table,.colist>table{border:0;background:none}
.hdlist>table>tbody>tr,.colist>table>tbody>tr{background:none}
td.hdlist1,td.hdlist2{vertical-align:top;padding:0 .625em}
td.hdlist1{font-weight:bold;padding-bottom:1.25em}
td.hdlist2{word-wrap:anywhere}
.literalblock+.colist,.listingblock+.colist{margin-top:-.5em}
.colist td:not([class]):first-child{padding:.4em .75em 0;line-height:1;vertical-align:top}
.colist td:not([class]):first-child img{max-width:none}
.colist td:not([class]):last-child{padding:.25em 0}
.thumb,.th{line-height:0;display:inline-block;border:solid 4px #fff;-webkit-box-shadow:0 0 0 1px #ddd;box-shadow:0 0 0 1px #ddd}
.imageblock.left{margin:.25em .625em 1.25em 0}
.imageblock.right{margin:.25em 0 1.25em .625em}
.imageblock>.title{margin-bottom:0}
.imageblock.thumb,.imageblock.th{border-width:6px}
.imageblock.thumb>.title,.imageblock.th>.title{padding:0 .125em}
.image.left,.image.right{margin-top:.25em;margin-bottom:.25em;display:inline-block;line-height:0}
.image.left{margin-right:.625em}
.image.right{margin-left:.625em}
a.image{text-decoration:none;display:inline-block}
a.image object{pointer-events:none}
sup.footnote,sup.footnoteref{font-size:.875em;position:static;vertical-align:super}
sup.footnote a,sup.footnoteref a{text-decoration:none}
sup.footnote a:active,sup.footnoteref a:active{text-decoration:underline}
#footnotes{padding-top:.75em;padding-bottom:.75em;margin-bottom:.625em}
#footnotes hr{width:20%;min-width:6.25em;margin:-.25em 0 .75em;border-width:1px 0 0}
#footnotes .footnote{padding:0 .375em 0 .225em;line-height:1.3334;font-size:.875em;margin-left:1.2em;margin-bottom:.2em}
#footnotes .footnote a:first-of-type{font-weight:bold;text-decoration:none;margin-left:-1.05em}
#footnotes .footnote:last-of-type{margin-bottom:0}
#content #footnotes{margin-top:-.625em;margin-bottom:0;padding:.75em 0}
.gist .file-data>table{border:0;background:#fff;width:100%;margin-bottom:0}
.gist .file-data>table td.line-data{width:99%}
div.unbreakable{page-break-inside:avoid}
.big{font-size:larger}
.small{font-size:smaller}
.underline{text-decoration:underline}
.overline{text-decoration:overline}
.line-through{text-decoration:line-through}
.aqua{color:#00bfbf}
.aqua-background{background:#00fafa}
.black{color:#000}
.black-background{background:#000}
.blue{color:#0000bf}
.blue-background{background:#0000fa}
.fuchsia{color:#bf00bf}
.fuchsia-background{background:#fa00fa}
.gray{color:#606060}
.gray-background{background:#7d7d7d}
.green{color:#006000}
.green-background{background:#007d00}
.lime{color:#00bf00}
.lime-background{background:#00fa00}
.maroon{color:#600000}
.maroon-background{background:#7d0000}
.navy{color:#000060}
.navy-background{background:#00007d}
.olive{color:#606000}
.olive-background{background:#7d7d00}
.purple{color:#600060}
.purple-background{background:#7d007d}
.red{color:#bf0000}
.red-background{background:#fa0000}
.silver{color:#909090}
.silver-background{background:#bcbcbc}
.teal{color:#006060}
.teal-background{background:#007d7d}
.white{color:#bfbfbf}
.white-background{background:#fafafa}
.yellow{color:#bfbf00}
.yellow-background{background:#fafa00}
span.icon>.fa{cursor:default}
a span.icon>.fa{cursor:inherit}
.admonitionblock td.icon [class^="fa icon-"]{font-size:2.5em;text-shadow:1px 1px 2px rgba(0,0,0,.5);cursor:default}
.admonitionblock td.icon .icon-note::before{content:"\f05a";color:#19407c}
.admonitionblock td.icon .icon-tip::before{content:"\f0eb";text-shadow:1px 1px 2px rgba(155,155,0,.8);color:#111}
.admonitionblock td.icon .icon-warning::before{content:"\f071";color:#bf6900}
.admonitionblock td.icon .icon-caution::before{content:"\f06d";color:#bf3400}
.admonitionblock td.icon .icon-important::before{content:"\f06a";color:#bf0000}
.conum[data-value]{display:inline-block;color:#fff!important;background:rgba(0,0,0,.8);-webkit-border-radius:50%;border-radius:50%;text-align:center;font-size:.75em;width:1.67em;height:1.67em;line-height:1.67em;font-family:"Open Sans","DejaVu Sans",sans-serif;font-style:normal;font-weight:bold}
.conum[data-value] *{color:#fff!important}
.conum[data-value]+b{display:none}
.conum[data-value]::after{content:attr(data-value)}
pre .conum[data-value]{position:relative;top:-.125em}
b.conum *{color:inherit!important}
.conum:not([data-value]):empty{display:none}
dt,th.tableblock,td.content,div.footnote{text-rendering:optimizeLegibility}
h1,h2,p,td.content,span.alt{letter-spacing:-.01em}
p strong,td.content strong,div.footnote strong{letter-spacing:-.005em}
p,blockquote,dt,td.content,span.alt{font-size:1.0625rem}
p{margin-bottom:1.25rem}
.sidebarblock p,.sidebarblock dt,.sidebarblock td.content,p.tableblock{font-size:1em}
.exampleblock>.content{background:#fffef7;border-color:#e0e0dc;-webkit-box-shadow:0 1px 4px #e0e0dc;box-shadow:0 1px 4px #e0e0dc}
.print-only{display:none!important}
@page{margin:1.25cm .75cm}
@media print{*{-webkit-box-shadow:none!important;box-shadow:none!important;text-shadow:none!important}
html{font-size:80%}
a{color:inherit!important;text-decoration:underline!important}
a.bare,a[href^="#"],a[href^="mailto:"]{text-decoration:none!important}
a[href^="http:"]:not(.bare)::after,a[href^="https:"]:not(.bare)::after{content:"(" attr(href) ")";display:inline-block;font-size:.875em;padding-left:.25em}
abbr[title]::after{content:" (" attr(title) ")"}
pre,blockquote,tr,img,object,svg{page-break-inside:avoid}
thead{display:table-header-group}
svg{max-width:100%}
p,blockquote,dt,td.content{font-size:1em;orphans:3;widows:3}
h2,h3,#toctitle,.sidebarblock>.content>.title{page-break-after:avoid}
#header,#content,#footnotes,#footer{max-width:none}
#toc,.sidebarblock,.exampleblock>.content{background:none!important}
#toc{border-bottom:1px solid #dddddf!important;padding-bottom:0!important}
body.book #header{text-align:center}
body.book #header>h1:first-child{border:0!important;margin:2.5em 0 1em}
body.book #header .details{border:0!important;display:block;padding:0!important}
body.book #header .details span:first-child{margin-left:0!important}
body.book #header .details br{display:block}
body.book #header .details br+span::before{content:none!important}
body.book #toc{border:0!important;text-align:left!important;padding:0!important;margin:0!important}
body.book #toc,body.book #preamble,body.book h1.sect0,body.book .sect1>h2{page-break-before:always}
.listingblock code[data-lang]::before{display:block}
#footer{padding:0 .9375em}
.hide-on-print{display:none!important}
.print-only{display:block!important}
.hide-for-print{display:none!important}
.show-for-print{display:inherit!important}}
@media print,amzn-kf8{#header>h1:first-child{margin-top:1.25rem}
.sect1{padding:0!important}
.sect1+.sect1{border:0}
#footer{background:none}
#footer-text{color:rgba(0,0,0,.6);font-size:.9em}}
@media amzn-kf8{#header,#content,#footnotes,#footer{padding:0}}
</style>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css"> <!--
  Copyright (c) 2010, 2023 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <style>
.menu, .submenu, .menuitem, .menuref {
    background-color: Menu;
}

.button {
    border: 1px solid ButtonFace;
    /*
    Styling too similar to a real button is considered bad practice, see https://github.com/asciidoctor/asciidoctor/issues/1881#issuecomment-250702085
    border: 2px outset ButtonFace;
    background-color: ButtonFace;
    */
    padding-left: 0.5ex;
    padding-right: 0.5ex;
    font-weight: normal;
    font-family: "Segoe UI","Open Sans","DejaVu Sans",sans-serif;
    white-space: nowrap;
}
.button:before {
    content: none !important;
}
.button:after {
    content: none !important;
}

#footer-text, #footer-text a {
    color: rgba(255,255,255,.8)
}

.toc-cur-page {
    font-weight: bold;
}
</style>
 </head>
 <body class="book toc2 toc-left">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="..">Chi website</a></p>
    <div id="toctitle">
     Chi documentation (Incubation)
    </div>
    <ul class="sectlevel1">
     <li><a href="../documentation.html">Home</a></li>
     <li><a href="../tutorial/index.html">Chi Tutorial</a>
      <ul class="sectlevel2">
       <li><a href="../tutorial/introduction.html">Introduction</a></li>
       <li><a href="../tutorial/datatypes.html">Data types</a></li>
       <li><a href="../tutorial/statements.html">Statements</a></li>
       <li><a href="../tutorial/functions.html">Functions</a></li>
       <li><a href="../tutorial/input-output.html">Input and output</a></li>
       <li><a href="../tutorial/stochastic-behavior.html">Modeling stochastic behavior</a></li>
       <li><a href="../tutorial/processes.html">Processes</a></li>
       <li><a href="../tutorial/channels.html">Channels</a></li>
       <li><a href="../tutorial/buffers.html">Buffers</a></li>
       <li><a href="../tutorial/servers.html">Servers with time</a></li>
       <li><a href="../tutorial/conveyors.html">Conveyors</a></li>
       <li><a href="../tutorial/experiments.html">Simulations and experiments</a></li>
       <li><a href="../tutorial/svg-visualization.html">SVG visualization</a></li>
       <li><a href="../tutorial/svg-example.html">SVG visualization example</a></li>
      </ul></li>
     <li><a href="index.html">Chi Reference Manual</a>
      <ul class="sectlevel2">
       <li><a href="globals.html">Global definitions</a></li>
       <li><a href="#" class="toc-cur-page">Statements</a></li>
       <li><a href="expressions.html">Expressions</a></li>
       <li><a href="stdlib.html">Standard library functions</a></li>
       <li><a href="distributions.html">Distributions</a></li>
       <li><a href="types.html">Types</a></li>
       <li><a href="lexicals.html">Lexical syntax</a></li>
       <li><a href="migration.html">Model migration</a></li>
       <li><a href="svg-visualization.html">SVG visualization</a></li>
      </ul></li>
     <li><a href="../tool-manual/index.html">Chi Tool Manual</a>
      <ul class="sectlevel2">
       <li><a href="../tool-manual/operation.html">Software operation</a></li>
       <li><a href="../tool-manual/command-line.html">Command line options</a></li>
      </ul></li>
     <li><a href="../release-notes.html">Chi release notes</a>
      <ul class="sectlevel2">
       <li><a href="../release-notes.html#version-0-10-2023-06-30">Version 0.10 (2023-06-30)</a></li>
       <li><a href="../release-notes.html#version-0-9-2023-03-31">Version 0.9 (2023-03-31)</a></li>
       <li><a href="../release-notes.html#version-0-8-2022-12-21">Version 0.8 (2022-12-21)</a></li>
       <li><a href="../release-notes.html#version-0-7-2022-09-30">Version 0.7 (2022-09-30)</a></li>
       <li><a href="../release-notes.html#version-0-6-2022-07-07">Version 0.6 (2022-07-07)</a></li>
       <li><a href="../release-notes.html#version-0-5-2022-03-29">Version 0.5 (2022-03-29)</a></li>
       <li><a href="../release-notes.html#version-0-4-2021-12-17">Version 0.4 (2021-12-17)</a></li>
       <li><a href="../release-notes.html#version-0-3-2021-10-01">Version 0.3 (2021-10-01)</a></li>
       <li><a href="../release-notes.html#version-0-2-2021-07-07">Version 0.2 (2021-07-07)</a></li>
       <li><a href="../release-notes.html#version-0-1-2021-04-02">Version 0.1 (2021-04-02)</a></li>
      </ul></li>
     <li><a href="../documentation-legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../documentation.html">Chi documentation (Incubation)</a> &gt; <a class="breadcrumb" href="index.html">Chi Reference Manual</a> &gt; <span class="breadcrumb">Statements</span>
   </div>
   <h2 id="statements"><a class="anchor" href="#"></a>Statements</h2>
   <div class="paragraph">
    <p>Statements express how a process or function in a system works. They define what is done and in which order. Many statements use data for their decisions, which is stored in local variables. The combined local variables and statements are called 'body' with the following syntax.</p>
   </div>
   <div class="imageblock">
    <div class="content"><img src="rail_diagrams/body.rr.png" alt="body.rr">
    </div>
   </div>
   <div class="paragraph">
    <p>Data values available to the process are the global constants (see <a href="globals.html#constant-definitions">Constant definitions</a>) and enumeration values (see <a href="globals.html#enumeration-definitions">Enumeration definitions</a>). The formal parameters of the surrounding process definition (explained in <a href="globals.html#process-definitions">Process definitions</a>) or the surrounding function definition (explained in <a href="globals.html#function-definitions">Function definitions</a>) are added as well.</p>
   </div>
   <div class="paragraph">
    <p>Data storage that can be modified by the process are the local variables, defined by the <code>VarDefinitions</code> block in the <code>Body</code> diagram above (variable definitions are explained below in <a href="#local-variables">Local variables</a>).</p>
   </div>
   <div class="paragraph">
    <p>The data values and the modifiable data storage is used by the statements of the <code>Body</code> in the path after <code>1</code>. For ease of reference they are grouped by kind of statement as shown in the <code>Statement</code> diagram below.</p>
   </div>
   <div class="imageblock">
    <div class="content"><img src="rail_diagrams/statement.rr.png" alt="statement.rr">
    </div>
   </div>
   <div class="ulist">
    <ul>
     <li><p>The <code>AssignmentStatement</code> is used to assign new values to the local variables (and explained further in <a href="#assignment-statement">Assignment statement</a>).</p></li>
     <li><p>The <code>IterativeStatement</code> allows repeated execution of the same statements by means of the <code>for</code> and <code>while</code> statements (further explained in <a href="#iterative-statements">Iterative statements</a>).</p></li>
     <li><p>The <code>ChoiceStatement</code> allows selection on which statement to perform next by means of the <code>if</code> statement (explained in <a href="#choice-statement">Choice statement</a>).</p></li>
     <li><p>The <code>run</code> and <code>start</code> statements of the <code>SubProcessStatement</code> group (explained in <a href="#sub-process-statements">Sub-process statements</a>) start new processes.</p></li>
     <li><p>Communication with other processes using channels is done with send, receive, and <code>select</code> statements in <code>CommunicationStatement</code> (explained in <a href="#communication-statements">Communication statements</a>)</p></li>
     <li><p>Finally, the <code>OtherStatements</code> group contains several different statements (explained further in <a href="#other-statements">Other statements</a>). The more commonly used statements in that group are the <code>delay</code> statement, the <code>write</code> statement, and the <code>return</code> statement.</p></li>
    </ul>
   </div>
   <div class="paragraph">
    <p>The syntax diagram of <code>Body</code> states that statements are separated from each other with a semicolon (<code>;</code>). The compiler allows more freedom. Semicolons may be omitted before and after a <code>end</code> keyword, and a semicolon may be added after the last statement.</p>
   </div>
   <div class="sect3">
    <h3 id="local-variables"><a class="anchor" href="#local-variables"></a>Local variables</h3>
    <div class="paragraph">
     <p>Local variables are introduced in a process or function using the following syntax.</p>
    </div>
    <div class="imageblock">
     <div class="content"><img src="rail_diagrams/vardef.rr.png" alt="vardef.rr">
     </div>
    </div>
    <div class="paragraph">
     <p>Variable definitions start with a <code>Type</code> node (its syntax if explained in <a href="types.html">Types</a>), followed by a sequence of variable names where each variable may be initialized with a value by means of the <code>= Expression</code> path. If no value is assigned, the variable gets the default value of the type. Use a semicolon to terminate the sequence of new variables.</p>
    </div>
    <div class="paragraph">
     <p>Next, another set of variables may be defined by going back to the start of the diagram, and giving another <code>Type</code> node, or the diagram can be ended, and the statements of the process or function can be given.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="assignment-statement"><a class="anchor" href="#assignment-statement"></a>Assignment statement</h3>
    <div class="paragraph">
     <p>An assignment statement assigns one or more values to the local variables. Its syntax is as follows.</p>
    </div>
    <div class="imageblock">
     <div class="content"><img src="rail_diagrams/assignment_statement.rr.png" alt="assignment statement.rr">
     </div>
    </div>
    <div class="paragraph">
     <p>The assignment statement computes the value of every <code>Expression</code> at the right. If there is one expression, its value is also the value to assign. If there are more expressions, a tuple value is constructed, combining all values into one tuple (see <a href="expressions.html#tuple-expression">Tuple expression</a> for a discussion of tuple values).</p>
    </div>
    <div class="paragraph">
     <p>At the left, a number of <code>Addressable</code> blocks define where the computed value is assigned to.</p>
    </div>
    <div class="imageblock">
     <div class="content"><img src="rail_diagrams/addressable.rr.png" alt="addressable.rr">
     </div>
    </div>
    <div class="paragraph">
     <p>An <code>Addressable</code> is a variable. If the variable has a tuple type (see <a href="types.html#tuple-type">Tuple type</a>) a field of the tuple may be assigned only using Path 1. Similarly, if the variable is a list (see <a href="types.html#list-type">List type</a>) or a dictionary (see <a href="types.html#dictionary-type">Dictionary type</a>) assignment is done to one element by using Path 2. The <code>Expression</code> here is evaluated before <em>any</em> assignment by this statement is performed. Since selected elements may also have a type that allows selection, element selection can be repeated.</p>
    </div>
    <div class="paragraph">
     <p>After processing the element selections at the left, it is known where values are assigned to. If there is exactly one addressable at the left, its type must match with the type of the value at the right (which may be a constructed tuple value as explained above). The value gets copied into the variable (or in its element if one is selected). If there are several addressable values at the left, the number of values must be equal to the length of the tuple from the expression(s) at the right, and each field of the right tuple must pair-wise match with the type of the addressed element at the left. In the latter case, all assignments are done at the same moment.</p>
    </div>
    <div class="paragraph">
     <p>For a few examples, a number of variable declarations are needed:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlight"><code class="language-chi" data-lang="chi">int x, y;
real r;
list(10) int xs;
tuple(real v; int w) t;
func tuple(real v; int w) (int) f;

...  # Initialization of the variables omitted</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>The variable declarations introduce integer variables <code>x</code> and <code>y</code>, a real number variable <code>r</code>, a list of 10 integers <code>xs</code>, a tuple <code>t</code> with two fields, and a function variable <code>f</code>.</p>
    </div>
    <div class="paragraph">
     <p>For reasons of clarity, initialization of the variables has been omitted. Also, expressions at the right are simple values. However, you may use all allowed expression operations explained in the next chapter (<a href="expressions.html">Expressions</a>) to obtain a value to assign. The first assignments show assignment of values to variables where there is one explicit value for every assigned variable:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlight"><code class="language-chi" data-lang="chi">x = 3;
t = f(y);
x, y = 4, 5;
xs[0], t.v = x+x, r;</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>The first assignment statement assigns 3 to <code>x</code>. The second assignment assigns the return value of the function call <code>f(y)</code> to tuple <code>t</code>. The third assignment assigns 4 to <code>x</code> and 5 to <code>y</code> at the same time. The fourth assignment assigns the value of <code>x+x</code> to the first element of the list <code>xs</code>, and the value of <code>r</code> to the <code>v</code> field of tuple <code>t</code>.</p>
    </div>
    <div class="paragraph">
     <p>The next assignments show combining or splitting of tuples:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlight"><code class="language-chi" data-lang="chi">t = r, y;
r, x = t;
r, x = f(y);</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>The first assignment assigns a new value to every field of tuple <code>t</code> (<code>t.v</code> gets the value of <code>r</code>, while <code>t.w</code> gets the value of <code>y</code>). This is called <em>packing</em>, it 'packs' the sequence of values into one tuple. The opposite operation is demonstrated in the second assignment. The value of each field of <code>t</code> is assigned to a separate variable. The types of the variables at the left have to pair-wise match with the field types of the tuple at the right. This assignment is called <em>unpacking</em>, it 'unpacks' a tuple value into its separate elements. The third assignment does the same as the second assignment, the difference is that the value at the right is obtained from a function call. The origin of the value is however irrelevant to the assignment statement.</p>
    </div>
    <div class="paragraph">
     <p>To demonstrate the order of evaluation, the following assignment, under the assumption that variable <code>x</code> holds value 3:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlight"><code class="language-chi" data-lang="chi">x, xs[x-1] = 7, x+2;</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>The assignment first computes all values at the right. Since there are more than one expression, they are combined into a tuple:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlight"><code class="language-chi" data-lang="chi">x, xs[x-1] = (7, 5);</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Next, the addressable values are calculated:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlight"><code class="language-chi" data-lang="chi">x, xs[2] = (7, 5);</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Finally the values are assigned, <code>x</code> gets a new value 7, while the third element of <code>xs</code> gets the value of expression <code>x+2</code>.</p>
    </div>
    <div class="paragraph">
     <p>The expressions at the right as well as the expressions to select elements in lists and dictionaries are always evaluated using values from before the assignment.</p>
    </div>
    <div class="paragraph">
     <p>It is forbidden to assign the same variable or selected element more than once:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlight"><code class="language-chi" data-lang="chi">x, x = 3, 3         # Error, assigned 'x' twice.
xs[0], xs[1] = 0, 1 # Allowed, different selected elements.
xs[0], xs[x] = 0, 1 # Allowed if x != 0.</code></pre>
     </div>
    </div>
   </div>
   <div class="sect3">
    <h3 id="iterative-statements"><a class="anchor" href="#iterative-statements"></a>Iterative statements</h3>
    <div class="paragraph">
     <p>The iterative statements are shown below.</p>
    </div>
    <div class="imageblock">
     <div class="content"><img src="rail_diagrams/iterative_statement.rr.png" alt="iterative statement.rr">
     </div>
    </div>
    <div class="paragraph">
     <p>The Chi language has two statements for repeatedly executing a body (a sequence of statements), a <code>while</code> statement and a <code>for</code> statement. The former is the generic iterative statement, the latter simplifies the common case of iterating over a collection of values.</p>
    </div>
    <div class="paragraph">
     <p>The <code>break</code> and <code>continue</code> statements change the flow of control in the iterative statements.</p>
    </div>
    <div class="sect4">
     <h4 id="while-loop-statement"><a class="anchor" href="#while-loop-statement"></a>While loop statement</h4>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/while_statement.rr.png" alt="while statement.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>A while loop starts with the keyword <code>while</code> with a boolean condition. Between the colon and the <code>end</code> keyword, the body of statements is given, which is executed repeatedly.</p>
     </div>
     <div class="paragraph">
      <p>Executing an iterative <code>while</code> statement starts with evaluating the boolean condition. If it does not hold, the <code>while</code> statement ends (and execution continues with the statement following the while statement). If the condition holds, the statements in the body are executed from start to end (unless a <code>break</code> or <code>continue</code> statement is executed, as explained below). After the last statement has been executed, the <code>while</code> statement starts again from the beginning, by evaluating the boolean condition again.</p>
     </div>
     <div class="paragraph">
      <p>As an example, consider the following code:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">int s, i;

while i &lt; 10:
    s = s + i
    i = i + 1
end</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>At first, the <code>i &lt; 10</code> condition holds, and the body of the <code>while</code> statement (two assignment statements) is executed. After the body has finished, <code>i</code> has been incremented, but is still less than <code>10</code>. The condition again holds, and the body is again executed, etc. This process continues, until the final statement of the body increments <code>i</code> to <code>10</code>. The condition does not hold, and execution of the <code>while</code> statement ends.</p>
     </div>
    </div>
    <div class="sect4">
     <h4 id="for-loop-statement"><a class="anchor" href="#for-loop-statement"></a>For loop statement</h4>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/for_statement.rr.png" alt="for statement.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>A common case for iterating is to execute some statements for every value in a collection, for example a list:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">list int xs;
int x;
int i;

while i &lt; size(xs):
    x = xs[i]
    ...
    i = i + 1
end</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>where the <code>...</code> line represents the statements that should be executed for each value <code>x</code> of the list. This is a very common case. Chi has a special statement for it, the <code>for</code> statement. It looks like:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">list int xs;

for x in xs:
    ...
end</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>This code performs the same operation, the statements represented with <code>...</code> are executed for each value <code>x</code> from list <code>xs</code>, but it is shorter and easier to write. The advantages are mainly a reduction in the amount of code that must be written.</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>No need to create and update the temporary index variable <code>i</code>.</p></li>
       <li><p>Variable <code>x</code> is declared implicitly, no need to write a full variable declaration for it.</p></li>
      </ul>
     </div>
     <div class="paragraph">
      <p>The behavior is slightly different in some circumstances.</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>There is no index variable <code>i</code> that can be accessed afterwards.</p></li>
       <li><p>When the <code>...</code> statements modify the source variable (<code>xs</code> in the example), the <code>while</code> statement above uses the changed value. The <code>for</code> statement continues to use the original value of the source variable.</p></li>
      </ul>
     </div>
     <div class="paragraph">
      <p>Continuing use of the original source value can be an advantage or a disadvantage, depending on the case. Using the new value gives more flexibility, keeping the old value makes the <code>for</code> statement more predictable, for example indices in the source variable stay valid.</p>
     </div>
     <div class="paragraph">
      <p>Besides iterating over a list with <code>for</code>, you can also iterate over element values of a set, or over key-value tuples of a dictionary, for example:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">dict(int:int) d = {1:10, 2:20};

for k, v in d:
    writeln("%s: %s", k, v);
end</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>When iterating over a set or a dictionary, the order of the elements is undefined. In the above example, the first pair is either <code>(1, 10)</code> or <code>(2, 20)</code>.</p>
     </div>
    </div>
    <div class="sect4">
     <h4 id="break-statement"><a class="anchor" href="#break-statement"></a>Break statement</h4>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/break_statement.rr.png" alt="break statement.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>The <code>break</code> statement may only be used inside the body of a loop statement. When executed, the inner-most loop statement ends immediately, and execution continues with the first statement after the inner-most loop statement. An example:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi"># Get a slice of the xs list, up-to the position of value x in the list
func get_until(list int xs, int x):
    int index;

    while index &lt; size(xs):
        if xs[index] == x:
            break
        end;
        index = index + 1
    end
    return xs[:index]
end</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>In the example, elements of the list <code>xs</code> are inspected until an element with a value equal to <code>x</code> is found. At that point, the loop ends with the <code>break</code> statement, and the function returns a slice of the list.</p>
     </div>
    </div>
    <div class="sect4">
     <h4 id="continue-statement"><a class="anchor" href="#continue-statement"></a>Continue statement</h4>
     <div class="paragraph">
      <p>Another common case when executing the body of an inner-most loop is that the remaining statements of the body should be skipped this time. It can be expressed with an <code>if</code> statement, but a <code>continue</code> statement is often easier.</p>
     </div>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/continue_statement.rr.png" alt="continue statement.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>The syntax of the continue statement is just <code>continue</code>. An example to demonstrate its operation:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">int s;

for x in xs:
    if x mod 5 == 0:
        continue
    end
    s = s + x
end</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>The <code>for</code> statement iterates over every value in list <code>xs</code>. When the value is a multiple of 5 (expressed by the condition <code>x mod 5 == 0</code>), the <code>continue</code> is executed, which skips the remaining statements of the body of the <code>for</code> statement, namely the <code>s = s + x</code> assignment. The result is that after executing the <code>for</code> statement, variable <code>s</code> contains the sum of all values of the list that are not a multiple of 5.</p>
     </div>
    </div>
   </div>
   <div class="sect3">
    <h3 id="choice-statement"><a class="anchor" href="#choice-statement"></a>Choice statement</h3>
    <div class="paragraph">
     <p>The choice statement, also known as 'if statement', selects one alternative from a list based on the current value of a boolean expression. The alternatives are tried in turn, until a boolean expression one an alternative yields true. The statements of that alternative are executed, and the choice statement ends. The choice statement also ends when all boolean expressions yield false. The boolean expression of the <code>else</code> alternative always holds.</p>
    </div>
    <div class="paragraph">
     <p>The syntax of the choice statement is as follows.</p>
    </div>
    <div class="imageblock">
     <div class="content"><img src="rail_diagrams/choice_statement.rr.png" alt="choice statement.rr">
     </div>
    </div>
    <div class="paragraph">
     <p>Processing starts with evaluating the <code>BooleanExpression</code> behind the <code>if</code>. If it evaluates to <code>true</code>, the statements behind it are executed, and the choice statement ends.</p>
    </div>
    <div class="paragraph">
     <p>If the boolean expression behind the <code>if</code> does not hold, the sequence <code>elif</code> alternatives is tried. Starting from the first one, each boolean expression is evaluated. If it holds, the statements of that alternative are performed, and the choice statement ends. If the boolean expression does not hold, the next <code>elif</code> alternative is tried.</p>
    </div>
    <div class="paragraph">
     <p>When there are no <code>elif</code> alternatives or when all boolean expressions of the <code>elif</code> alternatives do not hold, and there is an <code>else</code> alternative, the statements behind the <code>else</code> are executed and the choice statement ends. If there is no <code>else</code> alternative, the choice statement ends without choosing any alternative.</p>
    </div>
    <div class="paragraph">
     <p>An example with just one alternative:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlight"><code class="language-chi" data-lang="chi">if x == 1:
    x = 2
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>which tests for <code>x == 1</code>. If it holds, <code>x = 2</code> is performed, else no alternative is chosen.</p>
    </div>
    <div class="paragraph">
     <p>An longer example with several alternatives:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlight"><code class="language-chi" data-lang="chi">if x == 1:
     y = 5
elif x == 2:
    y = 6; x = 6
else:
    y = 7
end</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>This choice statement first tests whether <code>x</code> is equal to <code>1</code>. If it is, the <code>y = 5</code> statement is executed, and the choice statement finishes. If the first test fails, the test <code>x == 2</code> is computed. If it holds, the statements <code>y = 6; x = 6</code> are performed, and the choice statement ends. If the second test also fails, the <code>y = 7</code> statement is performed.</p>
    </div>
    <div class="paragraph">
     <p>The essential points of this statement are:</p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>The choice is computed now, you cannot wait for a condition to become true.</p></li>
      <li><p>Each alternative is tried from the top down, until the first expression that yields true.</p></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>The second point also implies that for an alternative to be chosen, the boolean expressions of all previous alternatives have to yield false.</p>
    </div>
    <div class="paragraph">
     <p>In the above example, while executing the <code>y = 7</code> alternative, you know that <code>x</code> is neither <code>1</code> nor <code>2</code>.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="sub-process-statements"><a class="anchor" href="#sub-process-statements"></a>Sub-process statements</h3>
    <div class="paragraph">
     <p>The sub-process statements deal with creating and managing of new processes. The statement may only be used in <a href="globals.html#process-definitions">Process definitions</a> and <a href="globals.html#model-definitions">Model definitions</a>.</p>
    </div>
    <div class="imageblock">
     <div class="content"><img src="rail_diagrams/subprocess_statement.rr.png" alt="subprocess statement.rr">
     </div>
    </div>
    <div class="paragraph">
     <p>The <code>RunStartStatement</code> block creates new processes (see <a href="#run-and-start-statements">Run and start statements</a> for details), while the <code>FinishStatement</code> waits for a process to end (further explanation at <a href="#finish-statement">Finish statement</a>).</p>
    </div>
    <div class="sect4">
     <h4 id="run-and-start-statements"><a class="anchor" href="#run-and-start-statements"></a>Run and start statements</h4>
     <div class="paragraph">
      <p>The <code>run</code> and <code>start</code> commands take a sequence of process instance as their argument.</p>
     </div>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/run_start.rr.png" alt="run start.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>Both statements start all instances listed in the sequence. The <code>start</code> statement ends directly after starting the processes, while the <code>run</code> statement waits until all the started instances have ended. Using <code>run</code> is generally recommended for creating new processes.</p>
     </div>
     <div class="paragraph">
      <p>A process instance has the following syntax.</p>
     </div>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/process_instance.rr.png" alt="process instance.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>The elementary process instance is created using Path 1. It consists of a process name (which must be one of the names of the <a href="globals.html#process-definitions">Process definitions</a>), followed by a sequence of actual parameters for the process between parentheses. The number of actual parameters and their types must match pair-wise with the number and type of the formal parameters of the referenced process definition. Channel directions of the formal parameters must be a sub-set of the channel directions of the actual parameters.</p>
     </div>
     <div class="paragraph">
      <p>The optional assignment of the process to a process variable (which must be of type <code>inst</code>, see <a href="types.html#instance-type">Instance type</a>) allows for checking whether the started process has ended, or for waiting on that condition in a <code>select</code> statement (explained in <a href="#select-statement">Select statement</a>), or with a <code>finish</code> statement (explained in <a href="#finish-statement">Finish statement</a>).</p>
     </div>
     <div class="paragraph">
      <p>For example:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">chan c;
inst p, q;

run P(18, c), Q(19, c);
start p = P(18, c), q = Q(19, c);</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>First two processes are completely run, namely the instances <code>P(18, c)</code>, and <code>Q(19, c)</code>. When both have ended, the <code>start</code> statement is executed, which starts the same processes, and assigned the <code>P</code> process instance to instance variable <code>p</code> and the <code>Q</code> process instance to variable <code>q</code>. After starting the processes, the <code>start</code> ends. Unless one of started processes has already ended, in the statement following the <code>start</code>, three processes are running, namely the process that executed the start statement, and the two started process instances referenced by variables <code>p</code> and <code>q</code>. (There may be more processes of course, created either before the above statements were executed, or the <code>P</code> or <code>Q</code> process may have created more processes.)</p>
     </div>
     <div class="paragraph">
      <p>Path 2 of the <code>ProcessInstance</code> diagram is used to construct many new processes by means of an <code>unwind</code> loop. Each value in the <code>Expression</code> gets assigned to the iterator variable sequence of <code>VariableName</code> blocks (and this may be done several times as the syntax supports several <code>Expression</code> loops). For each combination of assignments, the process instances behind the colon are created. The <code>end</code> keyword denotes the end of the <code>unwind</code>.</p>
     </div>
     <div class="paragraph">
      <p>Typical use of <code>unwind</code> is to start many similar processes, for example:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">list int xs = [1, 2]

run
    unwind i in range(5),
           j in range(3),
           x in xs: P(i, j, x)
    end;</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>This <code>run</code> statement runs 5*3*2 processes: <code>P(0, 0, 1)</code>, <code>P(0, 0, 2)</code>, <code>P(0, 1, 1)</code>, …​, <code>P(0, 2, 2)</code>, <code>P(1, 0, 1)</code>, …​, <code>P(4, 2, 2)</code>.</p>
     </div>
     <div class="paragraph">
      <p>Both the <code>run</code> and the <code>start</code> statements can always instantiate new processes that have no exit type specified. (see <a href="globals.html#process-definitions">Process definitions</a> for details about exit types in process definitions). If the definition containing the sub-process statement has an exit type, the statements can also instantiate processes with the same exit type.</p>
     </div>
     <div class="paragraph">
      <p>This requirement ensures that all exit statements in a model simulation give exit values of the same type.</p>
     </div>
    </div>
    <div class="sect4">
     <h4 id="finish-statement"><a class="anchor" href="#finish-statement"></a>Finish statement</h4>
     <div class="paragraph">
      <p>The <code>finish</code> statement allows waiting for the end of a process instance. The statement may only be used in <a href="globals.html#process-definitions">Process definitions</a> and <a href="globals.html#model-definitions">Model definitions</a>. Its syntax is as follows.</p>
     </div>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/finish_statement.rr.png" alt="finish statement.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>Each process variable must be of type <code>inst</code> (see <a href="types.html#instance-type">Instance type</a> for details). The statement ends when all referenced process instances have ended. For example:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">chan bool c;
inst p, q;

start p = P(18, c), q = Q(19, c);
finish p, q;</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>During the <code>start</code> statement (see <a href="#run-and-start-statements">Run and start statements</a>), instance variables <code>p</code> and <code>q</code> get a process instance assigned (this may also happen in different <code>start</code> statements). The <code>finish</code> statement waits until both process instances have ended.</p>
     </div>
    </div>
   </div>
   <div class="sect3">
    <h3 id="communication-statements"><a class="anchor" href="#communication-statements"></a>Communication statements</h3>
    <div class="paragraph">
     <p>Communication with another process is the only means to forward information from one process to another processes, making it the primary means to create co-operating processes in the modeled system. The statement may only be used in <a href="globals.html#process-definitions">Process definitions</a> and <a href="globals.html#model-definitions">Model definitions</a>.</p>
    </div>
    <div class="paragraph">
     <p>All communication is point-to-point (from one sender to one receiver) and synchronous (send and receive occur together). A communication often exchanges a message (a value), but communication without exchange of data is also possible (like waving 'hi' to someone else, the information being sent is 'I am here', but that information is already implied by the communication itself). The latter form of communication is called <em>synchronization</em>.</p>
    </div>
    <div class="paragraph">
     <p>Send and receive does not specify the remote process directly, instead a channel is used (see <a href="types.html#channel-type">Channel type</a> and <a href="expressions.html#channel-expressions">Channel expressions</a> sections for more informations about channels and how to create them). Using a channel increases flexibility, the same channel can be used by several processes (allowing communication with one of them). Channels can also be created and exchanged during execution, for even more flexibility.</p>
    </div>
    <div class="paragraph">
     <p>Setting up a communication channel between two processes is often done in the following way:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlight"><code class="language-chi" data-lang="chi">chan void sync;   # Synchronization channel
chan int  dch;    # Channel with integer number messages

run P(sync, dch), Q(sync, dch);</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>In a parent process, two channels are created, a synchronization channel <code>sync</code>, and a communication channel with data called <code>dch</code>. The channel values are given to processes <code>P</code> and <code>Q</code> through their formal parameters.</p>
    </div>
    <div class="paragraph">
     <p>The communication statements are as follows.</p>
    </div>
    <div class="imageblock">
     <div class="content"><img src="rail_diagrams/communication_statement.rr.png" alt="communication statement.rr">
     </div>
    </div>
    <div class="paragraph">
     <p>The elementary communication statements for sending and receiving at a single channel are the <a href="#send-statement">Send statement</a> and the <a href="#receive-statement">Receive statement</a>. The <a href="#select-statement">Select statement</a> is used for monitoring several channels and conditions at the same time, until at least one of them becomes available.</p>
    </div>
    <div class="sect4">
     <h4 id="send-statement"><a class="anchor" href="#send-statement"></a>Send statement</h4>
     <div class="paragraph">
      <p>The send statement send signals or data away through a channel. The statement may only be used in <a href="globals.html#process-definitions">Process definitions</a> and <a href="globals.html#model-definitions">Model definitions</a>. It has the following syntax:</p>
     </div>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/send_statement.rr.png" alt="send statement.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>The statement takes a channel value (derived from <code>ChannelExpression</code>), and waits until another process can receive on the same channel. When that happens, and the channel is a synchronization channel, a signal 'Communication has occurred' is being sent, if the channel also carries data, the <code>Expression</code> value is computed and sent to the other process. For example:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">proc P(chan void a, chan! int b):
    a!;
    b!21;
end</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>Process <code>P</code> takes two parameters, a synchronization channel locally called <code>a</code> and a outgoing channel called <code>b</code> carrying integer values. In the process body, it first synchronizes over the channel stored in <code>a</code>, and then sends the value <code>21</code> of the channel stored in <code>b</code>.</p>
     </div>
    </div>
    <div class="sect4">
     <h4 id="receive-statement"><a class="anchor" href="#receive-statement"></a>Receive statement</h4>
     <div class="paragraph">
      <p>The receive statement receives signals or data from a channel. The statement may only be used in <a href="globals.html#process-definitions">Process definitions</a> and <a href="globals.html#model-definitions">Model definitions</a>. It has the following syntax:</p>
     </div>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/receive_statement.rr.png" alt="receive statement.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>The statement takes a channel value (derived from the <code>ChannelExpression</code>), and waits until another process can send on the same channel. For synchronization channels, it receives just a signal that the communication has occurred, for channels carrying data, the data value is received and stored in the variable indicated by <code>Addressable</code>. For example:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">proc Q(chan void a, chan int b):
    int x;

    a?;
    b?x;
    writeln("%s", x);
end</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>Process <code>Q</code> takes a synchronization channel called <code>a</code> and a data channel for integer values called <code>b</code> as parameters. The process first waits for a synchronization over channel <code>a</code>, and then waits for receiving an integer value over channel <code>b</code> which is stored in local variable <code>x</code>.</p>
     </div>
    </div>
    <div class="sect4">
     <h4 id="select-statement"><a class="anchor" href="#select-statement"></a>Select statement</h4>
     <div class="paragraph">
      <p>The <a href="#send-statement">Send statement</a> and the <a href="#receive-statement">Receive statement</a> wait for communication over a single channel. In some cases, it is unknown which channel will be ready first. Additionally, there may be time-dependent internal activities that must be monitored as well. The select statement is the general purpose solution for such cases. The statement may only be used in <a href="globals.html#process-definitions">Process definitions</a> and <a href="globals.html#model-definitions">Model definitions</a>.</p>
     </div>
     <div class="paragraph">
      <p>It has the following syntax:</p>
     </div>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/select_statement.rr.png" alt="select statement.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>The statement has one or more <code>SelectCondition</code> alternatives that are all monitored. The first alternative is prefixed with <code>select</code> to denote it is a the start of a select statement, the other alternatives each start with <code>alt</code> (which is an abbreviation of 'alternative').</p>
     </div>
     <div class="paragraph">
      <p>The statement monitors all conditions simultaneously, waiting for at least one to become possible. At that moment, one of the conditions is selected to be executed, and the select statement ends.</p>
     </div>
     <div class="paragraph">
      <p>The syntax of a <code>SelectCondition</code> is:</p>
     </div>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/select_condition.rr.png" alt="select condition.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>In its simplest form, a <code>SelectCondition</code> is a <code>SelectAlternative</code> (taking Path 1). At Path 2, the condition is eventually also an <code>SelectAlternative</code>, but prefixed with an <code>unwind</code> construct, and with an additional <code>end</code> keyword at the end to terminate the unwind.</p>
     </div>
     <div class="paragraph">
      <p>The unwind construct allows for a compact notation of a large number of alternatives that must be monitored. Examples are provided below.</p>
     </div>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/select_alternative.rr.png" alt="select alternative.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>Using Path 1, a <code>SelectAlternative</code> can be a <a href="#send-statement">Send statement</a> or a <a href="#receive-statement">Receive statement</a>, which may optionally have a <code>BooleanExpression</code> condition prefix. Path 2 allows for a condition without a send or receive statement.</p>
     </div>
     <div class="paragraph">
      <p>The alternative checks the condition and monitors the channel. If the condition holds <em>and</em> the channel has a communication partner, the alternative can be chosen by the select statement. (Of course, omitting a condition skips the check, and not specifying a send or receive statement skips monitoring of the channel.) When an alternative is chosen by the select statement, the send or receive statement are performed (if it was present). If additional statements were given in the alternative using Path 3, they are executed after the communication has occurred (if a send or receive was present).</p>
     </div>
     <div class="paragraph">
      <p>A few examples to demonstrate use of the select statement:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">timer t = timer(5.2);

select
    a?
alt
    b!7:
        writeln("7 sent")
alt
    ready(t):
        writeln("done")
end</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>This select waits until it can receive a signal from channel <code>a</code>, it can send value <code>7</code> over channel <code>b</code>, or until <code>ready(t)</code> holds (which happens <code>5.2</code> time units after starting the <code>select</code>, see <a href="../tutorial/conveyors.html#timers">Timers</a> for details). If <code>b!7</code> was selected, the <code>writeln("7 sent")</code> is executed after the communication over channel <code>b</code>. If the <code>ready(t)</code> alternative is chosen, the <code>writeln("done")</code> is executed.</p>
     </div>
     <div class="paragraph">
      <p>A buffer can be specified with:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">list int xs;
int x;

select
    a?x:
        xs = xs + [x]
alt
    not empty(xs), b!xs[0]:
        xs = xs[1:]
end</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>The select either receives a value through channel <code>a</code>, or it sends the first element of list <code>xs</code> over channel <code>b</code> if the list is not empty (the condition must hold and the channel must be able to send an item at the same time to select the second alternative).</p>
     </div>
     <div class="paragraph">
      <p>After communication has been performed, the first alternative appends the newly received value <code>x</code> to the list (the received value is stored in <code>x</code> before the assignment is executed). In the second alternative, the assignment statement drops the first element of the list (which just got sent away over channel <code>b</code>).</p>
     </div>
     <div class="paragraph">
      <p>The <code>unwind</code> loop 'unwinds' alternatives, for example:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">list(5) chan int cs;
int x;

select
    unwind i, c in enumerate(cs):
        c?x:
            writeln("Received %s from channel number %d", x, i)
    end
end</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>Here <code>cs</code> is a list of channels, for example <code>list(5) chan int cs</code>. (See <a href="types.html#list-type">List type</a> for details about lists.) The <code>unwind</code> iterates over the <code>enumerate(cs)</code> (see <a href="expressions.html#list-expressions">List expressions</a> for details about <code>enumerate</code>), assigning the index and the channel to local <code>i</code> and <code>c</code> variables. The <code>SelectAlternative</code> uses the variables to express the actions to perform (wait for a receive, and output some text saying that a value has been received).</p>
     </div>
     <div class="paragraph">
      <p>The above is equivalent to (if list <code>cs</code> has length 5):</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">select
    cs[0]?x:
        writeln("Received %s from channel number %d", x, 0)
alt
    cs[1]?x:
        writeln("Received %s from channel number %d", x, 1)

...

alt
    cs[4]?x:
        writeln("Received %s from channel number %d", x, 4)</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>The <code>unwind</code> however works for any length of list <code>cs</code>. In addition, the <code>unwind</code> allows for nested loops to unfold for example <code>list list bool ds</code>, or to send one of several values over one of several channels.</p>
     </div>
    </div>
   </div>
   <div class="sect3">
    <h3 id="other-statements"><a class="anchor" href="#other-statements"></a>Other statements</h3>
    <div class="paragraph">
     <p>Finally, there are a number of other useful statements.</p>
    </div>
    <div class="imageblock">
     <div class="content"><img src="rail_diagrams/other_statements.rr.png" alt="other statements.rr">
     </div>
    </div>
    <div class="paragraph">
     <p>The <a href="#delay-statement">Delay statement</a> waits for the given amount of time units, the <a href="#write-statement">Write statement</a> outputs text to the screen or a file, the <a href="#close-statement">Close statement</a> closes a file, the <a href="#return-statement">Return statement</a> returns a value from a function. the <a href="#exit-statement">Exit statement</a> ends the execution of all processes, and the <a href="#pass-statement">Pass statement</a> does nothing.</p>
    </div>
    <div class="sect4">
     <h4 id="delay-statement"><a class="anchor" href="#delay-statement"></a>Delay statement</h4>
     <div class="paragraph">
      <p>The <code>delay</code> statement is useful to wait some time. The statement may only be used in <a href="globals.html#process-definitions">Process definitions</a> and <a href="globals.html#model-definitions">Model definitions</a>. It has the following syntax:</p>
     </div>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/delay_statement.rr.png" alt="delay statement.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>The <code>IntegerExpression</code> or <code>RealExpression</code> is evaluated, and is the amount of time that the statement waits. The value of the expression is computed only at the start, it is not evaluated while waiting. Changes in its value has thus no effect. A negative value ends the statement immediately, you cannot go back in time.</p>
     </div>
     <div class="paragraph">
      <p>Examples:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">delay 1.5   # Delay for 1.5 time units.</code></pre>
      </div>
     </div>
    </div>
    <div class="sect4">
     <h4 id="write-statement"><a class="anchor" href="#write-statement"></a>Write statement</h4>
     <div class="paragraph">
      <p>The write statement is used to output text to the screen or to a file. It has the following syntax:</p>
     </div>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/write_statement.rr.png" alt="write statement.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>The <em>format string</em> at 2 is a literal string value (further explained at <a href="expressions.html#string-expressions">String expressions</a>) which defines what gets written. Its text is copied to the output, except for two types of patterns which are replaced before being copied. Use of the <code>writeln</code> (write line) keyword causes an additional <code>\n</code> to be written afterwards.</p>
     </div>
     <div class="paragraph">
      <p>The first group of pattern are the back-slash patterns. They all start with the <code>\</code> character, followed by another character that defines the character written to the output. The back-slash patterns are listed in the table below.</p>
     </div>
     <table class="tableblock frame-all grid-all stretch">
      <colgroup>
       <col style="width: 50%;">
       <col style="width: 50%;">
      </colgroup>
      <thead>
       <tr>
        <th class="tableblock halign-left valign-top">Pattern</th>
        <th class="tableblock halign-left valign-top">Replaced by</th>
       </tr>
      </thead>
      <tbody>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>\n</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">The new-line character (U+000A)</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>\t</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">The tab character (U+0009)</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>\"</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">The double-quote character (U+0022)</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>\\</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">The back-slash character (U+005C)</p></td>
       </tr>
      </tbody>
     </table>
     <div class="paragraph">
      <p>The second group of patterns are the percent patterns. Each percent pattern starts with a <code>%</code> character. It is (normally) replaced by the (formatted) value of a corresponding expression listed after the format string (the first expression is used as replacement for the first percent pattern, the second expression for the second pattern, etc). How the value is formatted depends on the <em>format specifier</em>, the first letter after the percent character. Between the percent character and the format specifier may be a <em>format definition</em> giving control on how the value is output.</p>
     </div>
     <div class="paragraph">
      <p>The format definition consists of five parts, each part is optional.</p>
     </div>
     <div class="ulist">
      <ul>
       <li><p>A <code>-</code> character, denoting alignment of the value to the left. Cannot be combined with a <code>0</code>, and needs a <em>width</em>.</p></li>
       <li><p>A <code>+</code> character, denoting the value with always be printed with a sign, only for formatting decimal integers, and real numbers.</p></li>
       <li><p>A <code>0</code> character, denoting the value will be prefixed with zeros, only for integer numbers. Cannot be combined with <code>-</code>, and needs a <em>width</em>.</p></li>
       <li><p>A <em>width</em> as decimal number, denoting the minimal amount of space used for the value. The value will be padded with space (or zeros if the <code>0</code> part has been specified).</p></li>
       <li><p>A <code>.</code> and a <em>precision</em> as decimal number, denoting the number of digits to use for the fraction, only for real numbers.</p></li>
      </ul>
     </div>
     <div class="paragraph">
      <p>The format definition is a single letter, the table below lists them and their function.</p>
     </div>
     <table class="tableblock frame-all grid-all stretch">
      <colgroup>
       <col style="width: 50%;">
       <col style="width: 50%;">
      </colgroup>
      <thead>
       <tr>
        <th class="tableblock halign-left valign-top">Definition</th>
        <th class="tableblock halign-left valign-top">Description</th>
       </tr>
      </thead>
      <tbody>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>b</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">Output boolean value.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>d</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">Output integer value as decimal number.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>x</code>, <code>X</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">Output integer value as hexadecimal number.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>f</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">Output real value as number with a fraction.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>e</code>, <code>E</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">Output real value in exponential notation.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>g</code>, <code>G</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">Output real value either as <code>f</code> or as <code>e</code> (<code>E</code>) depending on the value</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>s</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">Output value as a string (works for every printable value)</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top"><p class="tableblock"><code>%</code></p></td>
        <td class="tableblock halign-left valign-top"><p class="tableblock">Output a <code>%</code> character</p></td>
       </tr>
      </tbody>
     </table>
    </div>
    <div class="sect4">
     <h4 id="close-statement"><a class="anchor" href="#close-statement"></a>Close statement</h4>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/close_statement.rr.png" alt="close statement.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>The <code>close</code> statement takes a value of type <code>file</code> as argument (see <a href="types.html#file-type">File type</a> for details about the file type). It closes the given file, which means that the file is no longer available for read or write. In case data was previously written to the file, the <code>close</code> statement ensures that the data ends up in the file itself.</p>
     </div>
     <div class="paragraph">
      <p>Note that a close of a file is global in the system, none of the processes can use the file any longer.</p>
     </div>
     <div class="paragraph">
      <p>In <a href="../tutorial/input-output.html#reading-from-a-file">Reading from a file</a> and <a href="../tutorial/input-output.html#writing-to-a-file">Writing to a file</a>, use of the close statement is shown.</p>
     </div>
    </div>
    <div class="sect4">
     <h4 id="return-statement"><a class="anchor" href="#return-statement"></a>Return statement</h4>
     <div class="paragraph">
      <p>The return statement may only be used in a <a href="globals.html#function-definitions">Function definitions</a>. It has the following syntax:</p>
     </div>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/return_statement.rr.png" alt="return statement.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>The statement starts with a <code>return</code> keyword, followed by one or more (comma-separated) expressions that form the value to return to the caller of the function.</p>
     </div>
     <div class="paragraph">
      <p>The value of the expressions are calculated, and combined to a single return value. The type of the value must match with the return type of the function. Execution of the function statements stops (even when inside a loop or in an alternative of an <code>if</code> statement), and the computed value is returned to the caller of the function.</p>
     </div>
     <div class="paragraph">
      <p>Examples:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">return 4          # Return integer value 4 to the caller.

return true, 3.7  # Return value of type tuple(bool b; real r).</code></pre>
      </div>
     </div>
    </div>
    <div class="sect4">
     <h4 id="exit-statement"><a class="anchor" href="#exit-statement"></a>Exit statement</h4>
     <div class="paragraph">
      <p>The <code>exit</code> statement may only be used in <a href="globals.html#process-definitions">Process definitions</a> and <a href="globals.html#model-definitions">Model definitions</a>. It has the following syntax:</p>
     </div>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/exit_statement.rr.png" alt="exit statement.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>The exit statement allows for immediately stopping the current model simulation. The statement may be used in <a href="globals.html#process-definitions">Process definitions</a> and <a href="globals.html#model-definitions">Model definitions</a>. If arguments are provided, they become the exit value of the model simulation. Such values can be processed further in an <a href="../tutorial/experiments.html#simulating-several-scenarios">Simulating several scenarios</a>, see also <a href="globals.html#experiment-definitions">Experiment definitions</a> on how to run a model in an experiment.</p>
     </div>
     <div class="paragraph">
      <p>The type of the combined arguments must match with the exit type of the process or model that uses the statement. If no arguments are given, the exit type must be a <code>void</code> type (see also <a href="types.html#void-type">Void type</a>).</p>
     </div>
     <div class="paragraph">
      <p>If an experiment is running, execution continues by returning from the model instantiation call. Otherwise, the simulation as a whole is terminated.</p>
     </div>
    </div>
    <div class="sect4">
     <h4 id="pass-statement"><a class="anchor" href="#pass-statement"></a>Pass statement</h4>
     <div class="imageblock">
      <div class="content"><img src="rail_diagrams/pass_statement.rr.png" alt="pass statement.rr">
      </div>
     </div>
     <div class="paragraph">
      <p>The <code>pass</code> statement does nothing. Its purpose is to act as a place holder for a statement at a point where there is nothing useful to do (for example to make an empty process), or to explicitly state nothing is being done at some point:</p>
     </div>
     <div class="listingblock">
      <div class="content">
       <pre class="highlight"><code class="language-chi" data-lang="chi">if x == 3:
    pass
else:
    x = x + 1
end</code></pre>
      </div>
     </div>
     <div class="paragraph">
      <p>Here, <code>pass</code> is used to explicitly state that nothing is done when <code>x == 3</code>. Such cases are often a matter of style, usually it is possible to rewrite the code and eliminate the <code>pass</code> statement.</p>
     </div>
    </div>
   </div>
  </div>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script> <!--
  Copyright (c) 2010, 2023 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>Chi documentation (Incubation)</span> | <span>Copyright (c) 2010, 2023 Contributors to the Eclipse Foundation</span> | <span>version v0.10</span><br> <a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>